--- Horde/Imap/Client/Socket.php.orig
+++ Horde/Imap/Client/Socket.php
@@ -647,6 +647,38 @@ class Horde_Imap_Client_Socket extends Horde_Imap_Client_Base
      */
     protected function _tryLogin($method)
     {
+        $n_tryLogin = 1;
+        while ($n_tryLogin <= 3) {  # Boucle CAS, pour renouveler le Proxy Ticket si besoin
+            try {
+                return $this->__tryLogin($method);
+                # On sort de la boucle CAS
+            } catch (Horde_Imap_Client_Exception $e) {
+                include_once('CAS.php');
+                //TODO if (! phpCAS::isAuthenticated() || $n_tryLogin > 2) {
+                if ($n_tryLogin > 3) {
+                    throw $e; // The exception goes upward
+                    break;
+                }
+                $n_tryLogin++;
+                // The login has failed, we try to renew the password (CAS Proxy Ticket)
+                Horde::logMessage('Trying to renew the password', 'INFO');
+                $GLOBALS['registry']->clearAuthApp('imp');
+                $pt = phpCAS::retrievePT('imaps://'.$this->getParam('hostspec'), $err_code, $output);
+                $this->setParam('password', $pt);
+            }
+        }   # Fin de la boucle CAS
+    }
+
+    protected function __tryLogin($method)
+    {
         $username = $this->getParam('username');
         $password = $this->getParam('password');

